    #include <stdio.h>
    #include <stdlib.h>
    #include <string.h>

    // dati
    /*
    Gli elementi del tipo ListaAnagrafe sono liste semplici di dati anagrafici (nome,
    cognome, et).
     */
    typedef struct Anagrafe {
      char nome[20];
      char cognome[20];
      int anni;
      struct Anagrafe* next;
    } Anagrafe;

    typedef Anagrafe* ListaAnagrafe;

    // consegne
    /*
    1. ListaAnagrafe togliOmonimi(ListaAnagrafe lista);
    La funzione togliOmonimi deve restituire la lista passata privata di eventuali
    omonimi (elementi con lo stesso nome, lo stesso cognome e la stessa et).
    2. double media(ListaAnagrafe lista, char iniziale);
    La funzione deve restituire l'et media di tutte le persone descritte nella lista i
    cui cognomi iniziano con il carattere iniziale.
    3. ListaAnagrafe unisci(ListaAnagrafe lista1, ListaAnagrafe
    lista2);
    La funzione prende in ingresso due liste prive di omonimi ed ordinate
    lessicograficamente, e restituisce una lista ordinata lessicograficamente che
    contiene tutti gli elementi che appartengono ad esse.
    */

    // 1)
    // funzione ausiliaria aggiungi se diverso
    void addif_l (ListaAnagrafe *l, char nome[], char cognome[], int anni) {
      if (l == NULL) return;
      if (*l == NULL) {
        *l = malloc (sizeof (Anagrafe));
        strcpy ((*l) -> cognome, cognome); // copio il valore di una stringa su un'altra
        strcpy ((*l) -> nome, nome);
        (*l) -> anni = anni;
        (*l) -> next = NULL;
        return;
      }
      if (
        strcmp ((*l) -> nome, nome) == 0 &&
        strcmp ((*l) -> cognome, cognome) == 0 &&
        (*l) -> anni == anni
      )
        return;
      return addif_l (&((*l) -> next), nome, cognome, anni);
    }

    ListaAnagrafe togliOmonimi(ListaAnagrafe lista) {
      ListaAnagrafe ln = NULL;
      while (lista != NULL) {
        addif_l (&ln, lista -> nome, lista -> cognome, lista -> anni);
        lista = lista -> next;
      }
      return ln;
    }

    // 2)
    double media (ListaAnagrafe lista, char iniziale) {
      int count, age;
      while (lista != NULL) {
        if ((lista -> cognome)[0] == iniziale) {
          age += lista -> anni;
          count ++;
        }
        lista = lista -> next;
      }
      if (count == 0) return 0; // considero questo caso altrimenti non si pu dividere per 0
      return age / count;
    }

    // 3)
    // funzione ausiliaria inserisci in ordine lessicografico
    void order_l (ListaAnagrafe *l, char nome[], char cognome[], int anni) {
      if (l == NULL) return;
      if (*l == NULL) {
        *l = malloc (sizeof (Anagrafe));
        strcpy ((*l) -> cognome, cognome);
        strcpy ((*l) -> nome, nome);
        (*l) -> anni = anni;
        (*l) -> next = NULL;
        return;
      }
      // inserisci se  lessicograficamente pi piccolo (cognome <, oppure cognome = e nome <=)
      // modifica la struttura della lista
      if (
        strcmp (cognome, (*l) -> cognome) < 0 ||
        (strcmp ((*l) -> cognome, cognome) == 0 && strcmp (nome, (*l) -> nome) <= 0)
      ) {
        ListaAnagrafe aux = *l;
        *l = malloc (sizeof (Anagrafe));
        strcpy ((*l) -> cognome, cognome);
        strcpy ((*l) -> nome, nome);
        (*l) -> anni = anni;
        (*l) -> next = aux;
        return;
      }
      return order_l (&((*l) -> next), nome, cognome, anni);
    }

    ListaAnagrafe unisci (ListaAnagrafe lista1, ListaAnagrafe lista2) {
      ListaAnagrafe ln = NULL;
      while (lista1 != NULL) {
        order_l (&ln, lista1 -> nome, lista1 -> cognome, lista1 -> anni);
        lista1 = lista1 -> next;
      }
      while (lista2 != NULL) {
        order_l (&ln, lista2 -> nome, lista2 -> cognome, lista2 -> anni);
        lista2 = lista2 -> next;
      }
      return ln;
    }

    // ALTRA VERSIONE, che tiene conto del fatto che le liste siano gi ordinate
    ListaAnagrafe unisci2 (ListaAnagrafe lista1, ListaAnagrafe lista2) {
      ListaAnagrafe l = NULL;
      if (lista1 == NULL && lista2 == NULL) return l;
      if (lista1 == NULL) { // ci sono ancora elementi in l2
        l = malloc (sizeof (Anagrafe));
        strcpy (l -> cognome, lista2 -> cognome);
        strcpy (l -> nome, lista2 -> nome);
        l -> anni = lista2 -> anni;
        l -> next = unisci2 (lista1, lista2 -> next);
        return l;
      }
      if (lista2 == NULL) {
        l = malloc (sizeof (Anagrafe));
        strcpy (l -> cognome, lista1 -> cognome);
        strcpy (l -> nome, lista1 -> nome);
        l -> anni = lista1 -> anni;
        l -> next = unisci2 (lista1 -> next, lista2);
        return l;
      }
      if (
        strcmp (lista1 -> cognome, lista2 -> cognome) < 0 ||
        (strcmp (lista1 -> cognome, lista2 -> cognome) == 0 && strcmp (lista1 -> nome, lista2 -> nome) <= 0)
      ) {
        l = malloc (sizeof (Anagrafe));
        strcpy (l -> cognome, lista1 -> cognome);
        strcpy (l -> nome, lista1 -> nome);
        l -> anni = lista1 -> anni;
        l -> next = unisci2 (lista1 -> next, lista2);
        return l;
      }
      l = malloc (sizeof (Anagrafe));
      strcpy (l -> cognome, lista2 -> cognome);
      strcpy (l -> nome, lista2 -> nome);
      l -> anni = lista2 -> anni;
      l -> next = unisci2 (lista1, lista2 -> next);
      return l;
    }

    // funzioni utili
    void add_l (ListaAnagrafe *l, char nome[], char cognome[], int anni) {
      if (l == NULL) return;
      if (*l == NULL) {
        *l = malloc (sizeof (Anagrafe));
        strcpy ((*l) -> cognome, cognome);
        strcpy ((*l) -> nome, nome);
        (*l) -> anni = anni;
        (*l) -> next = NULL;
        return;
      }
      return add_l (&((*l) -> next), nome, cognome, anni);
    }

    void print_l (ListaAnagrafe l) {
      while (l != NULL) {
        printf ("%s %s %d -> ", l -> cognome, l -> nome, l -> anni);
        l = l -> next;
      }
      printf ("NULL\n");
      return;
    }

    int main() {
      // test 1
      ListaAnagrafe l1 = NULL;
      add_l (&l1, "mario", "monti", 90);
      add_l (&l1, "mario", "moro", 20);
      add_l (&l1, "pino", "silvestri", 45);
      add_l (&l1, "pino", "silvestri", 45);
      add_l (&l1, "mario", "monti", 90);
      print_l (l1);
      ListaAnagrafe ln = togliOmonimi (l1);
      print_l (l1);
      print_l (ln);

      // test 2
      printf ("\n\n");
      print_l (ln);
      double n;
      n = media (ln, 'm');
      printf ("%f\n", n);

      // test 3
      printf ("\n\n");
      print_l (ln);
      ListaAnagrafe l2 = NULL;
      add_l (&l2, "gennaro", "gini", 60);
      add_l (&l2, "davide", "moro", 20);
      add_l (&l2, "silvestro", "silvestri", 47);
      print_l (l2);
      ListaAnagrafe l3 = NULL;
      l3 = unisci (ln, l2);
      printf ("\n");
      print_l (l3);

      printf ("\n");
      l3 = unisci2 (ln, l2);
      print_l (l3);

      return 0;
    }

