    #include <stdlib.h>
    #include <stdio.h>

    // dati
    /*
     Gli elementi del tipo Lista sono liste semplici di interi.
     Gli elementi di tipo ALista sono array i cui elementi sono di tipo Lista.
    */
    #define N 4
    typedef struct ListInt {
      int val;
      struct ListInt* next;
    } ListInt;

    typedef ListInt *Lista;

    typedef Lista ALista[N];

    // consegne
    /*
    1. int somma_multipli(ALista t, int h);
    La funzione deve restituire la somma di tutti gli interi contenuti nelle liste
    dell'array t che sono multipli di h (si assume h >1).
    2. Lista concatena(ALista t);
    La funzione concatena deve restituire una nuova lista ottenuta concatenando
    le liste che costituiscono gli elementi dell'array t.
    3. void ordina_lunghezze(ALista t );
    La procedura deve riordinarel'array t in modo che all'uscita dalla procedura
    valga la condizione seguente: per ogni indice i, la lunghezza della lista t[i] è
    minore o uguale alla lunghezza delle liste t[j] , per ogni j>i.
    */

    // 1)
    // funzione ausiliaria somma multipli di n in una lista
    int somma_m_l (Lista l, int n) {
      int somma = 0;
      while (l != NULL) {
        if ((l -> val) % n == 0)
          somma += l -> val;
        l = l -> next;
      }
      return somma;
    }

    int somma_multipli (ALista t, int h) {
      int i;
      int somma = 0;
      for (i = 0; i < N; i++)
        somma += somma_m_l (t[i], h);
      return somma;
    }

    // 2)
    // funzione ausiliaria aggiungi n in coda alla lista
    void add_n_l (Lista *l, int n) {
      if (l == NULL) return;
      if (*l == NULL) {
        *l = malloc (sizeof (ListInt));
        (*l) -> val = n;
        (*l) -> next = NULL;
        return;
      }
      return add_n_l (&((*l) -> next), n);
    }

    Lista concatena (ALista t) {
      int i;
      Lista ln = NULL;
      // per tutti gli elementi lista
      for (i = 0; i < N; i++) {
        // aggiungi ogni elemento della lista alla nuova lista
        Lista aux = t[i]; // uso una lista ausiliaria, altrimenti lascia il puntatore in coda a NULL
        while (aux != NULL) {
          add_n_l (&(ln), aux -> val);
          aux = aux -> next;
        }
      }
      return ln;
    }

    // 3
    // funzione ausiliaria lunghezza lista
    int lenght (Lista l) {
      int count = 0;
      while (l != NULL) {
        count++;
        l = l -> next;
      }
      return count;
    }
    // funzione ausiliaria swap per l'ordinamento
    void swap (Lista *l1, Lista *l2) {
      Lista temp = *l1;
      *l1 = *l2;
      *l2 = temp;
      return;
    }

    void ordina_lunghezze (ALista t) {
      int i, j;
      for (i = 0; i < (N - 1); i++)
        for (j = 0; j < (N - 1); j++)
          if (lenght (t[j]) > lenght (t[j + 1]))
            swap (&(t[j]), &(t[j + 1]));
      return;
    }

    // funzioni utili
    // creo lista da un array
    Lista a_l (int a[], int size) {
      if (size == 0) return NULL;
      Lista l = malloc (sizeof (ListInt));
      l -> val = a[0];
      l -> next = a_l (a + 1, size - 1);
      return l;
    }

    // stampa lista
    void print_l (Lista l) {
      while (l != NULL) {
        printf ("%d -> ", l -> val);
        l = l -> next;
      }
      printf ("NULL\n");
      return;
    }

    // stampa array di liste
    void print_al (ALista al) {
      int i;
      for (i = 0; i < N; i++) {
        print_l (al[i]);
      }
      return;
    }

    int main () {
      // test 1
      int a1[] = {1, 2, 6};
      int a2[] = {2, 2, 3};
      int a3[] = {4, 0, 2};

      Lista l1 = a_l (a1, 3);
      Lista l2 = a_l (a2, 3);
      Lista l3 = a_l (a3, 3);
      Lista l4 = NULL;

      ALista al = {l1, l2, l3, l4};

      printf ("%d\n", somma_multipli (al, 3));

      // test 2
      printf ("\n");
      add_n_l (&l1, 5);
      print_al (al);
      Lista ln = concatena (al);
      print_l (ln);

      // test 3
      add_n_l (&l2, 7);
      add_n_l (&l2, 0);
      printf ("\n");
      print_al (al);
      ordina_lunghezze (al);
      printf ("\n");
      print_al (al);

      return 0;
    }
