    #include <stdlib.h>
    #include <string.h>
    #include <stdio.h>

    // dati
    /*
    E' Carnevale, e l'esame di oggi vi chiede di gestire una fabbrica di frittelle.
    Per fare una confezione di frittelle ci vogliono: 1 etto di farina, 3 uova, 2 cucchiai di olio, e 3 cucchiai
    di zucchero.
    Ogni confezione di frittelle, una volta prodotta, sarà inserita in un pacco (che può contenere più
    confezioni) etichettato con il nome del cliente ed inserita in una lista di pacchi pronti per essere ritirati.
    Useremo i seguenti tipi
    */

    typedef struct {
      int farina;
      int uova;
      int olio;
      int zucchero;
    } Dispensa;

    typedef struct Pacco{
      char nome_cliente[10];
      int n_confezioni;
      struct Pacco* next;
    } Pacco;

    typedef Pacco* ListaPacchi;

    // consegne
    /*
    Esercizio 1: Implementare la seguente funzione:
    int produci(Dispensa* d);
    La procedura produci restituisce il numero massimo di confezioni di frittelle che si possono produrre con le quantità
    presenti nella dispensa *d. All'uscita della funzione, i valori dei campi di *d dovranno ovviamente essere decrementati in
    ragione degli ingredienti effettivamente consumati.

    Esercizio 2: Implementare la seguente procedura:
    ListaPacchi aggiungiPacco(ListaPacchi l, char* cliente, int numero_confezioni);
    La procedura aggiungiPacco aggiunge in coda alla lista l un nuovo pacco, destinato al cliente di nome cliente, e
    contenente numero_confezioni confezioni di frittelle.

    Esercizio 3: Implementare la seguente procedura:
    void ritiraPacco(ListaPacchi* l, char* cliente);
    La procedura ritiraPacco deve eliminare dalla lista l tutti i pacchi corripondenti al cliente di nome cliente
    presenti nella lista.
    */

    #define F 1
    #define U 3
    #define O 2
    #define Z 3

    // 1)
    // funzione ausiliaria che decrementa gli ingredienti di una dispensa
    void sub_n (Dispensa *d, int n) {
      (*d).farina -= F*n; // farina = farina - dose farina * n
      (*d).uova -= U*n;
      (*d).olio -= O*n;
      (*d).zucchero -= Z*n;
      return;
    }

    int produci(Dispensa* d) {
      int tot, div;
      div = (*d).farina / F;
      tot = div;
      div = (*d).uova / U;
      if (div < tot) tot = div;
      div = (*d).olio / O;
      if (div < tot) tot = div;
      div = (*d).zucchero / Z;
      if (div < tot) tot = div;

      sub_n (d, tot);
      return tot;
    }

    // 2)
    ListaPacchi aggiungiPacco(ListaPacchi l, char* cliente, int numero_confezioni) {
      if (l == NULL) {
        l = malloc (sizeof (Pacco));
        strcpy (l -> nome_cliente, cliente);
        l -> n_confezioni = numero_confezioni;
        l -> next = NULL;
        return l;
      }
      l -> next = aggiungiPacco (l -> next, cliente, numero_confezioni);
      return l;
    }

    // 3)
    void ritiraPacco(ListaPacchi* l, char* cliente) {
      if (l == NULL || *l == NULL) return;
      if (strcmp ((*l) -> nome_cliente, cliente) == 0) {
        ListaPacchi aux = *l;
        *l = (*l) -> next;
        free (aux);
        return ritiraPacco (l, cliente);
      }
      // se diverso continua
      return ritiraPacco (&((*l) -> next), cliente);
    }

    // funzioni utili
    // riempi dispensa
    void add (Dispensa *d, int f, int u, int o, int z) {
      (*d).farina = f;
      (*d).uova = u;
      (*d).olio = o;
      (*d).zucchero = z;
      return;
    }

    // stampa dispensa
    void print_d (Dispensa d) {
      printf ("farina %d, uova %d, olio %d, zucchero %d\n", d.farina, d.uova, d.olio, d.zucchero);
      return;
    }

    // stampa lista
    void print_l (ListaPacchi l) {
      while (l != NULL) {
        printf ("%s %d -> ", l -> nome_cliente, l -> n_confezioni);
        l = l -> next;
      }
      printf ("NULL\n");
      return;
    }

    int main() {
      // test 1
      Dispensa d;
      add (&d, 4, 7, 7, 9);
      //sub_n (&d, 1);
      print_d (d);
      int res = produci (&d);
      printf ("%d\n", res);
      print_d (d);

      // test 2
      printf ("\n\n");
      ListaPacchi lp = NULL;
      lp = aggiungiPacco (lp, "gino", 7);
      lp = aggiungiPacco (lp, "marco", 9);
      print_l (lp);

      // test 3
      printf ("\n\n");
      lp = aggiungiPacco (lp, "gino", 15);
      print_l (lp);
      ritiraPacco (&lp, "gino");
      print_l (lp);

      return 0;
    }
