    #include <stdlib.h>
    #include <stdio.h>
    #include <string.h>

    // dati
    /*
    Giugno e' mese di tasse, e la prova di oggi ha a che fare con le code allo sportello dell'ufficio imposte.
    Come spesso capita in questo tipo di uffici, la coda delle persone in attesa e' una sola, e non appena uno
    dei tre sportelli disponibili risulta libero, il primo in coda viene servito. Al termine del colloquio con
    l'operatore di sportello, la sua pratica viene messa in fondo alla lista delle pratiche che lo stesso
    operatore, a fine orario di apertura, dovra' poi smaltire. Per semplicita', tali pratiche saranno identificate
    allo stesso modo con cui si identificano le persone, ovvero con il loro codice fiscale.
    Per modellare questa situazione useremo i seguenti tipi:
    */
    typedef char Persona[16]; /* le persone sono identificate dal loro codice fiscale: 16 caratteri */

    typedef struct ListaPersone {
      Persona persona;
      struct ListaPersone* next;
    } ListaPersone;

    typedef struct Sportello{
      Persona* servito;
      /* indirizzo della persona servita allo
      sportello, NULL=sportello libero*/
      ListaPersone* lista; /* lista delle persone gia' servite a
      quello sportello */
    } Sportello;

    typedef struct Stato{
      ListaPersone* lista;
      Sportello sportello[3];
    } Stato;

    // consegne
    /*
    Esercizio 1: Implementare la seguente funzione:
    Stato* inizializza();
    La funzione inizializza restituisce l'indirizzo di una nuova variabile dinamica di tipo Stato che rappresenta la
    situazione iniziale ad inizio giornata: la lista delle persone in attesa e' ancora vuota, tutti e tre gli sportelli sono ancora liberi,
    e per ognuno dei tre sportelli, la lista delle persone gia' servite e' ancora vuota.

    Esercizio 2: Implementare la seguente procedura:
    void avantiIlProssimo(Stato *stato);
    La procedura avantiIlProssimo verifica se uno degli sportelli e' libero (altrimenti non fa nulla!), ed in tal caso toglie
    dalla lista delle persone in attesa il primo arrivato (se la lista delle persone in attesa e' vuota non fa nulla), e ne assegna
    l'indirizzo al campo servito di quello, tra gli sportelli liberi, che finora ha lavorato di meno (ovvero la cui lista di persone
    gia' servite e' piu' piccola). In caso di "parita'" tra sportelli, la persona sara' servita da sportello[i] con indice i piu' basso.

    Esercizio 3: Implementare la seguente procedura:
    void fattoAncheQuesto(Stato *stato, int num_sportello);
    La procedura fattoAncheQuesto deve aggiornare lo stato dopo che la persona che e' allo sportello di indice
    num_sportello e' stata servita: al campo servito di tale sportello viene assegnato il valore NULL, e la persona che era
    allo sportello viene inserita in cima alla lista delle persone gia' servite associata allo sportello stesso.
    */

    // 1)
    Stato* inizializza() {
      int i;
      // creo variabile dinamica
      Stato* s = (Stato *) malloc (sizeof (Stato)); // (Stato *) serve???
      // associo allo stato la lista vuota
      s -> lista = NULL;
      // creo l'array dei 3 sportelli
      for (i = 0; i < 3; i++)
          (s -> sportello)[i].servito = NULL;
          (s -> sportello)[i].lista = NULL;
      return s;
    }

    // 2)
    // funzione ausiliaria conta lunghezza lista
    int count (ListaPersone* l) {
      int c = 0;
      while (l != NULL) {
        c++;
        l = l -> next; // non modifico l'originale perché ListaPersone non è un ind
      }
      return c;
    }

    void avantiIlProssimo (Stato *stato) {
      int i, splibero;
      int libero = 0;
      int length;
      // verifico se c'è qualcuno in attesa altrimenti non faccio niente
      if ((stato -> lista) == NULL) return;
      // verifico se c'è almeno uno sportello libero e qual è il primo libero (mi serve dopo)
      for (i = 0; i < 3; i++)
        if ((stato -> sportello)[i].servito == NULL) {
          libero = 1;
          splibero = i;
          break; // appena lo trovo esco e memorizzo l'indice
        }
      if (libero == 0) return; // esci se non ci sono sportelli liberi

      // tolgo la prima persona dalla lista della coda
      Persona* p = &(stato -> lista -> persona); // prima salvo l'ind della persona
      stato -> lista = stato -> lista -> next; // poi la tolgo

      // scorro di nuovo l'array
      length = count ((stato -> sportello)[splibero].lista);
      for (i = 0; i < 3; i++)
        // confronto la lunghezza della lista solo nel caso lo sportello sia libero
        if ((stato -> sportello)[i].servito == NULL)
          if (count ((stato -> sportello)[i].lista) < length)
            splibero = i; // e sovrascrivo l'indice già trovato
      // aggiungo allo sportello trovato la persona in servito
      (stato -> sportello)[splibero].servito = p;
      return;
    }

    // 3)
    void fattoAncheQuesto (Stato *stato, int num_sportello) {
      // controllo che ci sia davvero una persona altrimenti non faccio nulla
      if ((stato -> sportello)[num_sportello].servito == NULL) return;
      // se c'è ne salvo l'indirizzo
      Persona* p = (stato -> sportello)[num_sportello].servito;
      // metto a NULL lo stato servito
      (stato -> sportello)[num_sportello].servito = NULL;
      // aggiungo la persona in testa alla lista dei serviti
      ListaPersone* ln = malloc (sizeof (ListaPersone));
      strcpy (ln -> persona, *p);
      free (p);
      ln -> next = (stato -> sportello)[num_sportello].lista;
      (stato -> sportello)[num_sportello].lista = ln;
      return;
    }

    // funzioni utili
    typedef ListaPersone *ListaPersoneI; // uso un indirizzo di lista per poterla modificare

    // stampa lista
    void print_l (ListaPersoneI l) {
      while (l != NULL) {
        printf ("%s, ", l -> persona);
        l = l -> next;
      }
      printf ("fine lista\n");
      return;
    }

    // stampa sportello
    void print_sp (Sportello sp) {
      if (sp.servito != NULL)
        printf ("persona \"%s\", ", *(sp.servito));
      else
        printf ("libero, ");
      printf ("persone già servite: ");
      print_l (sp.lista);
      return;
    }

    // stampa stato
    void print_s (Stato s) {
      int i;
      printf ("persone in coda: ");
      print_l (s.lista);

      for (i = 0; i < 3; i++) {
        printf ("sportello %d: ", i);
        print_sp (s.sportello[i]);
      }

      return;
    }

    // aggiungi persona in lista
    void add_p_l (ListaPersoneI *l, char str[16]) {
      if (l == NULL) return;
      if (*l == NULL) {
        *l = malloc (sizeof (Persona));
        strcpy ((*l) -> persona, str);
        (*l) -> next = NULL;
        return;
      }
      return add_p_l (&((*l) -> next), str);
    }

    int main () {
      // test 1
      Stato* s = inizializza();
      print_s (*s);

      // test 2
      printf("\n\n");
      // mi metto in coda
      ListaPersoneI lp = NULL;
      // ho messo un codice di 15 caratteri, la consegna dice 16 ma è un errore 
      // perché in quel caso la stringa dovebbe averne 17 (16 + \0)
      add_p_l (&lp, "mrodvd88e02f443");
      s -> lista = lp; // lp è già di tipo ListaPersone *
      print_s (*s);
      printf("\n");
      // aggiungo una persona allo sportello 1 in servito
      Persona p1 = "persona1"; // creo persona
      (s -> sportello)[0].servito = &p1; // associo l'ind a servito

      // e due persone già servite agli sportelli 2 e 3
      Persona p2 = "persona2";
      Persona p3 = "persona3";
      Persona p4 = "persona4";
      Persona p5 = "persona5";
      ListaPersoneI lp2 = NULL;
      add_p_l (&lp2, p2);
      add_p_l (&lp2, p3);
      ListaPersoneI lp3 = NULL;
      add_p_l (&lp3, p4);
      add_p_l (&lp3, p5);
      (s -> sportello)[1].lista = lp2;
      (s -> sportello)[2].lista = lp3;
      print_s (*s);

      avantiIlProssimo(s);
      printf ("\n");
      print_s (*s);

      // test 3
      printf ("\n\n");
      fattoAncheQuesto (s, 1);
      print_s (*s);

      return 0;
    }
