    #include <stdlib.h>
    #include <stdio.h>
    #include <math.h>

    // dati
    /*
    I centimetri di pioggia caduti nella ridente citta' di Mestre sono registrati giornalmente in una tabella
    bidimensionale, di dimensione 31*12: ad esempio, se il nome della tabella relativa al 2007 e' A, il valore
    contenuto in A[5][0] rappresenta la quantita' di pioggia caduta il 6 gennaio 2007, mentre A[27][11]
    rappresenta quanta pioggia e' caduta il 28 dicembre 2007.
    Per modellare questa situazione useremo il seguente tipo:
    */
    typedef double Pioggia_Anno[31][12];
    // consegne
    /*
    Esercizio 1: Implementare la seguente funzione:
    int mese_piu_piovoso(Pioggia_Anno pioggia);
    La funzione mese_piu_piovoso restituisce l'intero corrispondente al mese in cui e' caduta piu' pioggia, rispetto alla
    tabella bidimensionale di valori passata (se restituisce 2 vuol dire che guardando alla tabella passata, marzo e' stato il mese in
    cui sono caduti piu' centimetri di pioggia).

    Esercizio 2: Implementare la seguente funzione:
    double min_diff(Pioggia_Anno pioggia);
    La funzione min_diff identifica, nella tabella passata come parametro attuale, i due giorni in cui la quantita' di pioggia
    caduta e' diversa da 0.0 ed ha i valori piu' vicini, e restituisce la differenza di tali valori.

    Esercizio 3: Implementare la seguente procedura:
    Pioggia_Anno* crea(double k);
    La procedura crea deve restituire l'indirizzo di una nuova tabella di tipo Pioggia_Anno, allocata nello heap, ed inizializzata
    nel modo seguente:
    ad ogni cella significativa in un anno non bisestile deve essere assegnato il valore k
    alle celle non significative deve essere assegnato invece il valore 0.0
    Ad esempio: se a e' la tabella creata, alla cella a[12][4], che corrisponde al 13 maggio, sara' assegnato il valore k, mentre alla
    cella a[30][10], che corrisponderebbe al 31 novembre, e che quindi non e' una cella significativa, sara' assegnato il valore 0.0.
    */

    // 1)
    int mese_piu_piovoso (Pioggia_Anno pioggia) {
      int i, j, count, imese;
      int qt = -1;
      for (i = 0; i < 12; i++) {
        count = 0;
        for (j = 0; j < 31; j++)
          count += pioggia[j][i];
        if (count > qt) {
          qt = count;
          imese = i;
        }
      }
      return imese;
    }

    // 2)
    // funzione ausiliara che restituisce la differenza minima tra coppie in un array
    double diff (double a[], int size) {
      int i, j;
      double diff;
      double dist = -1;
      for (i = 0; i < size; i++)
        for (j = i + 1; j < size; j++) {
          if (a[i] > 0 && a[j] > 0) { // faccio la differenza solo tra giorni in cui ha piovuto
            diff = fabs (a[i] - a[j]);
            if (dist == -1 || diff < dist) // entra sempre al primo ciclo per dist = -1
              dist = diff;
          }
        }
      return dist;
    }

    double min_diff (Pioggia_Anno pioggia) {
      int g, m;
      int i = 0;
      // non chiedendo i giorni precisi ma solo la differenza di pioggia per comodità porto tutti i giorni in un array
      double a[372]; // 12 mesi * 31 giorni
      for (g = 0; g < 31; g++)
        for (m = 0; m < 12; m++, i++)
          a[i] = pioggia[g][m];
      return diff (a, 372);
    }

    int main() {
      // test 1
      // azzero array mesi
      Pioggia_Anno a;
      int i, j;
      for (i = 0; i < 31; i++)
        for (j = 0; j < 12; j++)
          a[i][j] = 0;
      // metto in gennaio tutti 2
      for (i = 0; i < 31; i++)
        a[i][0] = 2;
      // metto in marzo la sommatoria di 30
      for (i = 0; i < 31; i++)
        a[i][2] = i;
      // metto in maggio tutti 1
      for (i = 0; i < 31; i++)
        a[i][4] = 1;

      printf ("%d\n", mese_piu_piovoso (a));

      //test 2
      printf ("\n\n");
      // prova con i primi due mesi
      // gennaio tutti con diff di 1
      for (i = 0; i < 31; i++)
        a[i][0] = i; // 0, 1, 2 ...

      // febbraio tutti con diff di 2
      for (i = 0; i < 31; i++)
        a[i][1] = (i*2)+100; // 100, 102, ...

      // tra il 27 e 28 febbraio abbasso la diff da 154, 156 a 155.5, 156
      a[27][1] = 155.5;
      //printf ("%f, %f\n", a[27][1], a[28][1]);

      // azzero tutti gli altri mesi
      for (i = 0; i < 12; i++)
        for (j = 0; j < 31; j++)
          if (i != 0 && i != 1)
            a[j][i] = 0;

      printf ("%f\n", min_diff(a)); // rest 0.5, diff tra 27 e 28 febbraio

      return 0;
    }
