    #include <stdlib.h>
    #include <stdio.h>

    #define N 3
    #define M 4

    // dati
    /*
    Un cruciverba è una tabella bidimensionale:
    */

    typedef struct {
      int num;
      char car;
    } Elem;

    typedef Elem Cruciverba[N][M];

    /*
    dove N e M sono due costanti.
    Il campo num assume come valori: -1 se
    l'elemento è una casella nera, 0 se non è una
    definizione, n > 0 il numero della
    definizione.
    Il campo car assume come valori: il simbolo
    speciale '*' se è una casella nera, un carattere altrimenti.
    */

    // consegne
    /*
    Esercizio 1: char vocale (Cruciverba c, int dimr, int dimc);
    La funzione deve restituire una vocale che occorre il massimo numero di volte nel cruciverba.

    Esercizio 2: void stampaParole(Cruciverba c, int dimr, int dimc);
    La procedura stampa le parole presenti nel cruciverba in corrispondenza delle definizioni.
    Esempio Le parole relative al cruciverba in figura sono: scuola, ce, oh, asaoi, off, fs, salute, hip, pop, pluto, parola,
    famiglia, gioco, piu, bu, otto, tacco, ar, ce, aereo, la.

    Esercizio 3: void numera(Cruciverba c, int dimr, int dimc);
    Dato un cruciverba in cui sono presenti le parole e le caselle nere, la procedura aggiunge la numerazione in
    corrispondenza delle parole che sono definizioni.
    */

    // 1)
    // funzione ausiliaria che conta la vocale che compare più volte in un array
    char max_vocale (char a[], int size) {
      int i, j, count;
      char c;
      int tot = -1;
      for (i = 0; i < size; i++) {
        count = 0;
        for (j = i + 1; j < size; j++) {
          // escludo dalla ricerca le caselle nere
          if (a[i] != '*') {
            if (a[i] == a[j])
              count++;
            if (count > tot) { // sempre al primo ciclo
              tot = count;
              c = a[i];
            }
          }
        }
      }
      return c;
    }

    char vocale (Cruciverba c, int dimr, int dimc) {
      int row, col;
      int i = 0;
      char a[dimr * dimc];
      // porto tutto in un array che controllo con la funzione max_vocale
      for (row = 0; row < dimr; row++)
        for (col = 0; col < dimc; col++, i++)
          a[i] = c[row][col].car;
      return max_vocale (a, dimr * dimc);
    }

    // 2)
    // funzione ausiliarie che stampano una parola del cruciverba in orizzontale e in verticale
    void print_o (Cruciverba c, int n, int m, int dimc) {
      // stampa fino a che non eccede le colonne o non incontra una casella nera
      while ((m < dimc) && (c[n][m].num != -1)) {
        printf ("%c", c[n][m].car);
        m++;
      }
      printf ("\n");
      return;
    }

    void print_v (Cruciverba c, int n, int m, int dimr) {
      // stampa fino a che non eccede le righe o non incontra una casella nera
      while ((n < dimr) && (c[n][m].num != -1)) {
        printf ("%c", c[n][m].car);
        n++;
      }
      printf ("\n");
      return;
    }

    void stampaParole (Cruciverba c, int dimr, int dimc) {
      int n, m;
      // scorri tutto l'array e per ogni casella individua se è una definizione orizzontale e/o verticale
      for (n = 0; n < dimr; n++) {
        for (m = 0; m < dimc; m++) {
          // se c'è il numero della definizione e una casella a sx e questa non è nera
          if ((c[n][m].num > 0) && (m + 1 < dimc) && (c[n][m + 1].num >= 0)) {
            print_o (c, n, m, dimc);
          }
          // se c'è il numero della definizione e una casella sotto e questa non è nera
          if ((c[n][m].num > 0) && (n + 1 < dimr) && (c[n + 1][m].num >= 0)) {
            print_v (c, n, m, dimr);
          }
        }
      }
      return;
    }

    // 3)
    void numera (Cruciverba c, int dimr, int dimc) {
      int n, m;
      int i = 1;
      for (n = 0; n < dimr; n++) {
        for (m = 0; m < dimc; m++) {
          // se a sx non c'è niente o casella nera e a dx c'è una casella e non è nera (oriz.) o
          // se sopra non c'è niente o casella nera e sotto c'è una casella e non è nera (vert.)
          if (
          (((m - 1 < 0) || (c[n][m-1].num == -1)) && ((m + 1 < dimc) && (c[n][m+1].num != -1))) ||
          (((n - 1 < 0) || (c[n-1][m].num == -1)) && ((n + 1 < dimr) && (c[n+1][m].num != -1)))
          ) {
            c[n][m].num = i;
            i++;
          }
        }
      }
      return;
    }

    // funzioni utili
    // stampa il cruciverba
    void print_c (Cruciverba c) {
      int n, m;
      for (n = 0; n < N; n++) {
        for (m = 0; m < M; m++) {
          if (c[n][m].num == -1)
            printf ("- ");
          else
            //printf ("%d", c[n][m].num); // per vedere numero
            printf ("%c ", c[n][m].car);
        }
        printf ("\n");
      }
      return;
    }

    int main () {
      // test
      Cruciverba c;
      // prima riga
      c[0][0].num = 1;
      c[0][0].car = 'a';
      c[0][1].num = 0;
      c[0][1].car = 'r';
      c[0][2].num = 2;
      c[0][2].car = 'i';
      c[0][3].num = 3;
      c[0][3].car = 'a';

      // seconda riga
      c[1][0].num = 0;
      c[1][0].car = 'l';
      c[1][1].num = -1;
      c[1][1].car = '*';
      c[1][2].num = 4;
      c[1][2].car = 'l';
      c[1][3].num = 0;
      c[1][3].car = 's';

      // terza riga
      c[2][0].num = 5;
      c[2][0].car = 'a';
      c[2][1].num = 0;
      c[2][1].car = 'a';
      c[2][2].num = -1;
      c[2][2].car = '*';
      c[2][3].num = 0;
      c[2][3].car = 'd';

      // test 1
      print_c (c);
      //char a[] = {'a', 'i', 'u', 'o', 'i', 'i', 'j'};
      //printf("%c", max_vocale (a, 7));
      printf("%c", vocale (c, N, M));

      // test 2
      printf ("\n\n");
      /*
      print_o (c, 0, 0, M);
      print_v (c, 0, 0, N);
      */
      stampaParole (c, N, M);

      // test 3
      printf ("\n\n");
      int n, m;
      // azzero tutti i numeri delle definizioni (lasciando le caselle nere)
      for (n = 0; n < N; n++)
        for (m = 0; m < M; m++)
          if (c[n][m].num != -1)
            c[n][m].num = 0;
      print_c (c);
      numera (c, N, M);
      print_c (c);

      return 0;
    }
