    #include <stdlib.h>
    #include <stdio.h>
    #include <string.h>

    // dati
    /*
    Sono appena finite le Olimpiadi, e per il tutto il mese scorso abbiamo guardato ogni giorno lo stato del medagliere, per
    vedere quante medaglie (e di che tipo) avevamo preso, e come ci collocavamo rispetto agli altri stati.
    */
    typedef struct Medaglie {
      char nazione[20];    /* stringa con il nome della nazione */
      int oro;    /* numero medaglie d'oro */
      int argento;    /* numero medaglie d'argento */
      int bronzo;    /* numero medaglie di bronzo */
      struct Medaglie *next; /* prossima della lista */
    } Medaglie;

    typedef Medaglie *Medagliere;

    // consegne
    /*
    Esercizio 1: Implementare la seguente funzione:
    char *vincitore(Medagliere m);
    La funzione vincitore restituisce il nome (di tipo stringa) della nazione che ha il medagliere piu' ricco, ovvero di
    quella che ha piu' medaglie d'oro, o se altre nazioni hanno lo stesso numero di medaglie d'oro, quella che tra esse ha piu'
    medaglie d'argento, eccetera. Se m e' una lista vuota, la funzione deve restituire una stringa vuota. (NB: per semplicita'
    si assume che nel medagliere m non ci siano nazioni "ex-aequo").

    Esercizio 2: Implementare la seguente funzione:
    double mediaMedaglie(Medagliere m);
    La procedura mediaMedaglie restituisce la media per nazione delle medaglie (indipendentemente dal tipo) che
    risultano nel medagliere m.

    Esercizio 3: Implementare la seguente funzione:
    Medagliere dorate(Medagliere m);
    La funzione dorate restituisce un nuovo medagliere, che contenga solo le nazioni (e rispettive medaglie) che hanno
    almeno una medaglia d'oro nel medagliere m.
    */

    // funzione ausiliaria aggiungi in lista, per es 3 e utile in generale
    void add (Medagliere * m, char nazione[20], int oro, int argento, int bronzo) {
      if (m == NULL) return;
      if (*m == NULL) {
        *m = malloc (sizeof (Medaglie));
        strcpy ((*m) -> nazione, nazione);
        (*m) -> oro = oro;
        (*m) -> argento = argento;
        (*m) -> bronzo = bronzo;
        (*m) -> next = NULL;
        return;
      }
      return add (&((*m) -> next), nazione, oro, argento, bronzo);
    }

    // Es 1
    // funzione ausiliaria conta nazioni
    int count (Medagliere m) {
      int count = 0;
      while (m != NULL) {
        count ++;
        m = m -> next;
      }
      return count;
    }

    char *vincitore (Medagliere m) {
      char * c;
      if (m == NULL) {
        c = "";
        return c;
      }
      int nazione;
      int i = 0;
      int tot = -1;
      Medagliere aux;
      // conto la lista e creo un array di tanti elementi quante le nazioni
      int n = count (m);
      int a[n];
      // scorro tutta la lista (ausiliaria) per ogni nazione memorizzo nel rispettivo indice dell'array un numero
      // cifra centinaia = oro, decine = argento, unit = bronzo
      aux = m;
      while (aux != NULL) {
        a[i] = 100 * (aux -> oro) + 10 * (aux -> argento) + (aux -> bronzo);
        aux = aux -> next;
        i++;
      }
      // ora conto il numero pi alto dell'array scorrendolo
      for (i = 0; i < n; i++)
        if (a[i] > tot) { // sempre per la prima nazione perch tot = -1
          tot = a[i];
          nazione = i;
        }
      // ora ho l'indice della nazione con pi medaglie, scorro la lista originale per prendermi il suo nome
      i = 0;
      while (i != nazione) {
        m = m -> next;
        i ++;
      }
      c = m -> nazione;
      return c;
    }

    // Es 2)
    double mediaMedaglie (Medagliere m) {
      int i = 0;
      double count = 0;
      while (m != NULL) {
        count += (m -> oro) + (m -> argento) + (m -> bronzo);
        m = m -> next;
        i++;
      }
      if (i == 0) return 0; // per non fare 0/0!
      return count / i;
    }

    // Es 3)
    Medagliere dorate (Medagliere m) {
      Medagliere mn = NULL;
      while (m != NULL) {
        if (m -> oro > 0)
          add (&mn, m -> nazione, m -> oro, m -> argento, m -> bronzo);
        m = m -> next;
      }
      return mn;
    }

    // funzioni utili
    void print_m (Medagliere m) {
      while (m != NULL) {
        printf ("%s: %d %d %d -> ", m -> nazione, m -> oro, m -> argento, m -> bronzo);
        m = m -> next;
      }
      printf ("NULL\n");
    }

    int main () {
      // test 1
      Medagliere m = NULL;
      add (&m, "italia", 1, 3, 2);
      add (&m, "usa", 9, 3, 2);
      add (&m, "cina", 9, 3, 1);
      add (&m, "tibet", 0, 0, 1);
      print_m (m);

      char * c;
      c = vincitore (m);
      printf ("%s\n", c);

      // test 2
      printf("\n\n");
      // media  6+14+13+1 = 34 / 4 = 8.5
      printf ("%f\n", mediaMedaglie (m));

      // test 3
      printf("\n\n");
      Medagliere mn = dorate (m);
      print_m (mn);
      print_m (m);

      return 0;
    }
