    #include <stdlib.h>
    #include <stdio.h>

    // dati
    /*
    Qualcuno vi ha fatto un bello scherzo, mettendo le mani in cucina dove tenete pentole e coperchi: davanti a voi c'e' una
    pila di pentole e coperchi spaiati: sotto il coperchio del pentolino di acciaio c'e una casseruola di alluminio, con sotto
    una pirofila di vetro, e sotto ancora il coperchio del pentolino di acciaio... ma quello che e' peggio e' che non per tutte le
    pentole si trova il coperchio corrispondende, ne' viceversa!
    */
    typedef enum {Casseruola, Pirofila, Pentolino, Padella} Forma;

    typedef enum {Acciaio, Vetro, Alluminio} Materiale;

    typedef enum {Pentola, Coperchio} Parte;

    typedef struct BatteriaCucina{
      Forma forma;
      Materiale materiale;
      Parte parte;
      struct BatteriaCucina *next;
    } BatteriaCucina;

    typedef BatteriaCucina *ListaBatterie;

    // consegne
    /*
    Esercizio 1: Implementare la seguente funzione:
    int conta(ListaBatterie l, Materiale m);
    La funzione conta restituisce il numero di batterie complete (pentola e coperchio della stessa forma) di materiale m
    presenti nella lista l.

    Esercizio 2: Implementare la seguente funzione:
    ListaBatterie non_accoppiate(ListaBatterie l);
    La procedura non_accoppiate restituisce una lista con tutti gli elementi spaiati (quelli che rimangono dopo aver
    tolto dalla lista l le coppie "pentola e coperchio" della stessa forma e materiale).

    Esercizio 3: Implementare la seguente procedura:
    void totali(ListaBatterie l, int tabella[2][3]);
    All'uscita della procedura totali, nell'array bidimensionale di interi tabella (dove le righe sono relative alla parte
    e le colonne relative al materiale), dovremo avere i dati corretti relativi agli elementi presenti nella lista l,
    indipendentemente dalla forma : nella casella tabella[0][0]dovremo avere il numero totale di pentole di acciaio,
    nella casella tabella[1][2] il numero totale di coperchi di alluminio, eccetera.
    */

    // aggiungi in batteria, funzione ausiliara es 2 e utile per riempire una lista
    void add (ListaBatterie * l, Forma f, Materiale m, Parte p) {
      if (l == NULL) return;
      if ((*l) == NULL) {
        *l = malloc (sizeof (BatteriaCucina));
        (*l) -> forma = f;
        (*l) -> materiale = m;
        (*l) -> parte = p;
        (*l) -> next = NULL;
        return;
      }
      return add (&((*l) -> next), f, m, p);
    }


    // 1)
    int conta(ListaBatterie l, Materiale m) {
      int i, j;
      int count = 0;
      // creo un array di 4 forme per 2 parti (pentola e coperchio) e lo azzero
      int a[4][2];
      for (i = 0; i < 4; i++)
        for (j = 0; j < 2; j++)
          a[i][j] = 0;
      // incremento il valore relativo all'indice forma e parte per ogni pezzo che sia del materiale m
      while (l != NULL) {
        if (l -> materiale == m) {
          a[l -> forma][l -> parte]++;
        }
        l = l -> next;
      }
      // per ogni forma conto ci sia il coperchio e la pentola
      for (i = 0; i < 4; i++)
        count += (a[i][0] + a[i][1]) / 2; // se solo se sono in numero uguale sono multipli di 2
      return count;
    }

    // 2)
    ListaBatterie non_accoppiate (ListaBatterie l) {
      int i, j, k, pair;
      ListaBatterie aux = l;
      ListaBatterie ln = NULL;
      // creo un array in cui memorizzo 4 Forme * 3 Materiali * 2 Parti
      int a[4][3][2];
      // lo azzero
      for (i = 0; i < 4; i++)
        for (j = 0; j < 3; j++)
          for (k = 0; k < 2; k++)
            a[i][j][k] = 0;
      // scorro una lista ausiliaria e dispongo ogni elemento al punto giusto
      // cioè incremento il relativo valore dell'array
      while (aux != NULL) {
        a[aux -> forma][aux -> materiale][aux -> parte]++;
        aux = aux -> next;
      }
      // scorro di nuovo l'array modificandonde i valori
      for (i = 0; i < 4; i++)
        for (j = 0; j < 3; j++) { // per ogni forma e materiale conta le coppie di coperchi e pentole
          pair = (a[i][j][0] + a[i][j][1]) / 2; // es. 3 + 2 = 5 / 2 = 2 coppie
          a[i][j][0] = a[i][j][1] = pair; // quindi elimina 2 coperchi e 2 pentole
        }
      // elimino i valori dalla lista o meglio la scorro senza aggiungere i valori segnati dall'array in una nuova lista
      while (l != NULL) {
        // se l'elemento non è nell'array
        if (a[l -> forma][l -> materiale][l -> parte] == 0) {
          add  (&ln, l -> forma, l -> materiale, l -> parte); // prendilo
        }
        else a[l -> forma][l -> materiale][l -> parte]--; // altr. non prenderlo e decrementa q.tà nell'array 
        l = l -> next;
      }
      return ln;
    }

    // 3)
    void totali(ListaBatterie l, int tabella[2][3]) {
      int i, j;
      // azzero array
      for (i = 0; i < 2; i ++)
        for (j = 0; j < 3; j++)
          tabella[i][j] = 0;
      // scorro la lista
      while (l != NULL) {
        tabella[l -> parte][l -> materiale]++;
        l = l -> next;
      }
      return;
    }

    // funzioni utili

    // stampa batteria
    void print_l (ListaBatterie l) {
      while (l != NULL) {
        printf ("%d %d %d -> ", l -> forma, l -> materiale, l -> parte);
        l = l -> next;
      }
      printf ("NULL\n");
      return;
    }

    int main () {
      // test 1
      ListaBatterie l = NULL;
      add (&l, 3, 0, 1); // padella acciaio coperchio
      add (&l, 2, 2, 0); // pentolino alluminio pentola
      add (&l, 3, 0, 1); // padella acciaio coperchio (non accoppiata)
      add (&l, 3, 0, 0); // padella acciaio pentola + 1
      add (&l, 3, 0, 1); // padella acciaio coperchio
      add (&l, 3, 0, 0); // padella acciaio pentola + 1
      add (&l, 2, 2, 1); // pentolino alluminio coperchio
      print_l (l);
      printf ("%d\n", conta (l, 0));

      // test 2
      printf ("\n\n");
      print_l (l);
      ListaBatterie ln = non_accoppiate(l);
      print_l (ln);

      // test 3
      // 3 cop acciaio, 2 pentole acciaio, 1 pentola all, 1 coperchio alluminio
      printf ("\n\n");
      int t[2][3];
      totali (l, t);

      int i, j;
      for (i = 0; i < 2; i ++) {
        for (j = 0; j < 3; j++)
          printf ("%d ", t[i][j]);
        printf ("\n");
      }

      return 0;
    }
